Attribute VB_Name = "swf_Prefs"
' module: swf - prefs
' McT / 29.01.03
' checked ~ 1.1

Option Explicit

' *********************************************
' const
' *********************************************

Public Const NoteID = "McTNote"

Public Const StandardID = 99
Public Const CounterID_Len = 2

Public Const SymbolID = "McTSymbol_"
Public Const SymbolID_Len = 10

Public Const x = 0
Public Const y = 1

' *********************************************
' types
' *********************************************

Public Type sfsObject
    id As Long
    maxRoughStr As String
    methodestr As String
    methodeWidth As Double
    sfsType As Long
    x As Double
    y As Double
End Type

' *********************************************
' vars
' *********************************************

' -> sw vars
Public sw As Object, drw As Object, view As Object
Public sheetLockUsr As Boolean, sheetLockCur As Boolean
Public sheetName$, nSpace&

Public p0(1) As Double, pN(1) As Double
Public d0#, d1#, d2#, d3#, d4#, d5#, drwPosX(5) As Double, drwPosY(5) As Double
Public noteStr$, sFontName$, bFontName$, sFontSize&, bFontSize&

Public sfsList(5) As sfsObject, sfsCount&, methodeWidthSum#, oldSFS(20) As Object, oldSFScount&

Private i&

' *********************************************
' calculations
' *********************************************

Public Function getTextWidth(Optional txt$ = "", Optional fontName$ = "", Optional fontHeight& = 0) As Double
' *************
' -> calculate txt offset cused by additional sfs notes
' *************
    
    With swf_MainForm
        
        If fontName <> "" Then .txtCalc.fontName = fontName
        If fontHeight <> 0 Then .txtCalc.FontSize = fontHeight
        getTextWidth = 0
        If txt <> "" Then getTextWidth = .txtCalc.TextWidth(txt) / 1000
    
    End With

End Function

Public Sub CalcWidths()
' *************
' -> calc text widths
' *************

    Dim curWidth#
    methodeWidthSum = 0
    ' -> calc each and add all
    For i = 0 To sfsCount
        curWidth = getTextWidth(sfsList(i).methodestr) * fontXScale
        sfsList(i).methodeWidth = curWidth
        If i <> 0 Then methodeWidthSum = methodeWidthSum + curWidth
    Next i

End Sub

Public Sub CalcPos()
' *************
' -> calc positions
' *************
    
    On Error GoTo errorCalc

    ' -> set text style
    getTextWidth , sFontName, sFontSize
    ' -> calc
    CalcWidths

    ' -> ***** base point ******
    Dim buf, formatX#
    buf = drw.GetCurrentSheet.GetProperties
    Select Case buf(0)
        Case swDwgPaperA4sizeVertical: formatX = drwPosX(4)
        Case swDwgPaperA3size: formatX = drwPosX(3)
        Case swDwgPaperA2size: formatX = drwPosX(2)
        Case swDwgPaperA1size: formatX = drwPosX(1)
        Case swDwgPaperA0size: formatX = drwPosX(0)
        Case Else: formatX = 0
    End Select
    
    p0(x) = formatX
    p0(y) = drwPosY(0)
    
    ' -> ***** p1, .., pn *****
    
    For i = 1 To sfsCount
        ' -> y
        sfsList(i).y = p0(y) + d0
        ' -> x
        If i = 1 Then
        Dim a#
            a = (d2 - d3) + d1 + sfsList(i).methodeWidth
            sfsList(i).x = p0(x) - d1 - (d2 - d3) - sfsList(i).methodeWidth
        Else
            sfsList(i).x = sfsList(i - 1).x - d2 - d4 - sfsList(i).methodeWidth
        End If

    Next i
        
    ' -> ***** standard *****
    
    ' -> y
    sfsList(0).y = p0(y) + d0
    ' -> x
    If sfsCount > 0 Then
        ' -> calc not position & dimensions
        CalcNotePos
        sfsList(0).x = sfsList(sfsCount).x - d1 - d2 - sfsList(0).methodeWidth
    Else
        sfsList(0).x = p0(x) - d1 - sfsList(0).methodeWidth - (d2 - d3)
    End If

    Exit Sub

errorCalc:

    GEF.Raise "Fehler bei der Berechnung !", swf_MainForm.Caption, swf_MainForm.Icon
    swf_MainForm.shutDown

End Sub

Private Sub CalcNotePos()
' *******************************************
' note
' *******************************************

    ' -> note string
    Dim s&, maxW#, curW
    maxW = 2 * d1 + sfsCount * d2 + (sfsCount - 1) * d4 + (methodeWidthSum)
    ' -> set text style
    getTextWidth , bFontName, bFontSize
    i = 0
    Do
        i = i + 1
        curW = getTextWidth("(" + Space(i) + ")")
    Loop Until curW >= maxW
    
    noteStr = "(" + Space(i - 1) + ")"
    curW = getTextWidth(noteStr)
    ' -> note pos
    pN(y) = p0(y) + d5
    pN(x) = p0(x) + (maxW - curW) / 2 - maxW

End Sub


